------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3769 $ $Date: 2010-10-24 03:16:28 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------

package body Qt4.Size_Policies is

   function new_QSizePolicy return not null access Qt4_Entities.Cpp_Class;
   pragma Import (C, new_QSizePolicy, "__Qt4Ada_new_QSizePolicy");

   function copy_QSizePolicy
    (Cpp_Object : not null access Qt4_Entities.Cpp_Class)
     return not null access Qt4_Entities.Cpp_Class;
   pragma Import (C, copy_QSizePolicy, "__Qt4Ada_copy_QSizePolicy");

   procedure delete_QSizePolicy
    (Cpp_Object : not null access Qt4_Entities.Cpp_Class);
   pragma Import (C, delete_QSizePolicy, "__Qt4Ada_delete_QSizePolicy");

   procedure assign_QSizePolicy
    (S_1 : not null access          Thin.QSizePolicy;
     S_2 : not null access constant Thin.QSizePolicy);
   pragma Import (C, assign_QSizePolicy, "__Qt4Ada_assign_QSizePolicy");

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Copy_Cpp_Object
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   overriding function Copy_Cpp_Object (Self : not null access Q_Size_Policy)
     return not null access Qt4_Entities.Cpp_Class
   is
   begin
      return copy_QSizePolicy (Self.Cpp_Object);
   end Copy_Cpp_Object;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Create
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   function Create return Q_Size_Policy is
      Result : Q_Size_Policy;
   begin
      return Result;
   end Create;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Default_Cpp_Object
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   overriding function Default_Cpp_Object (Self : not null access Q_Size_Policy)
     return access Qt4_Entities.Cpp_Class
   is
      pragma Unreferenced (Self);
      --  Параметр необходим для диспетчеризации надклассового вызова.

   begin
      return new_QSizePolicy;
   end Default_Cpp_Object;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Delete_Cpp_Object
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   overriding
   procedure Delete_Cpp_Object (Self : not null access Q_Size_Policy)
   is
   begin
      delete_QSizePolicy (Self.Cpp_Object);
   end Delete_Cpp_Object;

   package body Internals is

      ------------------------------------------------------------------------
      --! <Subprogram>
      --!    <Unit> Cpp_Object
      --!    <ImplementationNotes>
      ------------------------------------------------------------------------
      function Cpp_Object (Self : Q_Size_Policy)
        return not null access Thin.QSizePolicy
      is
      begin
         return Qt4_Entities.Cpp_Object (Self);
      end Cpp_Object;

      ------------------------------------------------------------------------
      --! <Subprogram>
      --!    <Unit> To_Q_Size_Policy
      --!    <ImplementationNotes>
      ------------------------------------------------------------------------
      function To_Q_Size_Policy
       (Item : not null access constant Thin.QSizePolicy)
          return Q_Size_Policy
      is
      begin
         return Result : Q_Size_Policy do
            assign_QSizePolicy (Internals.QSizePolicy_View (Result), Item);
         end return;
      end To_Q_Size_Policy;

   end Internals;

end Qt4.Size_Policies;
